;;; -*- Mode: Lisp -*-
;;; browser-wrap.l --- browser.l g₷ wrap

;; Author: OHKUBO Hiroshi <konata_o@hotmail.com>
;; Time-stamp: <2001/12/29 13:54:33 +0900>

;;; Commentary:

;; Description:
;;
;;  satoshi oowada ̌JĂ browser.dll, browser.l 
;;  g₷bv܂B
;;  c[o[o^܂B
;;
;;  satoshi oowada  xyzzy ֘A WEB TCg URI
;;  http://oowada.pobox.ne.jp/xyzzy/xyzzy.html

;; Installation:
;;
;;      1. browser.dll, browser.l g悤ɂ܂B
;;
;;      2. 𓀂 browser-wrap.l  ~/site-lisp ɃRs[܂B
;;         toolbar-browser.bmp  ~/etc ɃRs[܂B
;;
;;      3. (KvȂ)oCgRpC܂B
;;
;;             M-x byte-compile-file
;;
;;      4. .xyzzy ܂ siteinit.l Ɉȉ̃R[hǉ܂B
;;
;;             (load-library "browser-wrap")
;;
;;      5. L̐ݒ𔽉f邽߂ɁAxyzzy ċN܂B
;;         siteinit.l ɋLqꍇ xyzzy ă_vċN܂B
;;
;;      6. KvȂ΃j[́u\vuc[o[vɒǉĂ
;;         uBrowserv`FbNAc[o[\܂B

;; Uninstallation:
;;
;;      1. browser-wrap.l ɊւLq폜܂B
;;
;;      2. siteinit.l ɋLqĂꍇ xyzzy ă_v܂B
;;
;;      3. ESC ESC (delete-command-bar 'browser-tool-bar)
;;         ƃ^CvAj[́u\vuc[o[v
;;         uBrowserv폜܂B
;;

;; Changes:
;;      Sat, 29 Dec 2001 13:40:14 +0900
;;              EL[[hp[^̎ẘԈႢCB
;;
;;      Thu, 27 Dec 2001 02:40:56 +0900
;;              Etoolbar.bmp ɈˑĂ xyzzy ɖf˂Ȃ
;;                ACR̕ύXÂ炩肷̂ toolbar-browser.bmp 
;;                Ă݂B
;;                toolbar-browser.bmp  ~/etc ɃRs[ĂB
;;
;;      Sat, 22 Dec 2001 21:13:21 +0900
;;              Ec[o[Ă݂B
;;                ɔ autoload łȂāAload-library B
;;
;;      Fri, 07 Dec 2001 23:39:26 +0900
;;              Ee|t@C̕R[h̃obt@Ɠ
;;                Ȃ悤ɏCB
;;
;;      Fri, 07 Dec 2001 00:00:00 +0900
;;              Et@ĈȂobt@̏ꍇ̓e|t@C
;;                쐬 navigate ł悤ɁB
;;                navigate-current-buffer navigate-current-buffer-with-check ǉB
;;                rotate-browser CB
;;

;;; Code:

(provide "browser-wrap")

(require "browser")

(defun refresh-browser ()
  (interactive)
  (if initialized
      (browser-refresh)))

;; xyzzy-ml [xyzzy:04489]
;; 2ch [xyzzy part2] 758-759
(let ((dll "Browser.dll"))
  (c:define-dll-entry c:int browser-createex (c:int (c:void *) c:int c:int) dll "_createEx@16"))

(define-history-variable *browser-position* 3) ; 0=, 1=, 2=E, 3=
(defvar *browser-size* 200)
(defvar *browser-start-page* "http://www.jsdlab.co.jp/~kamei/")

(defun navigate (url &key position size)
  (interactive "sURL: " :default0 *browser-start-page*)
  (if (null position)
      (setq position *browser-position*))
  (if (null size)
      (setq size *browser-size*))
  (unless initialized
    (setq initialized t)
    (browser-createex (get-window-handle) (si:plugin-arg) size position))
  (browser-navigate (si:make-string-chunk url)))

;;
(defvar *browser-temp-file*
  (map-backslash-to-slash
   (merge-pathnames "browser-temp.html"
                    (or (si:getenv "TEMP")
                        (si:getenv "TMP")
                        (si:system-root)))))

(defun navigate-current-buffer (&key position size temp-file)
  (interactive)
  (let ((file (get-buffer-file-name)))
    (if file
        (navigate file :position position :size size)
      (progn
        (unless temp-file
          (setq temp-file *browser-temp-file*))
        (with-open-file (out temp-file
                             :direction :output
                             :if-does-not-exist :create)
          (convert-encoding-from-internal
           (buffer-fileio-encoding)
           (buffer-substring (point-min) (point-max)) out))
        (navigate temp-file :position position :size size)))))

(defun navigate-current-buffer-with-check (&key position size temp-file)
  (interactive)
  (if initialized
      (navigate-current-buffer :position position
                               :size size
                               :temp-file temp-file)))
;;
(defun navigate-current-file (&key position size)
  (interactive)
  (let ((file (get-buffer-file-name)))
    (if file
        (navigate file :position position :size size))))
(defun navigate-current-file-with-check (&key position size)
  (interactive)
  (if initialized
      (navigate-current-file :position position :size size)))
(defun save-buffer-and-navigate-current-file-with-check (&key position size)
  (interactive)
  (save-buffer)
  (navigate-current-file-with-check :position position :size size))
; save-buffer-with-time-stamp -- auto-time-stamp.l
(defun save-buffer-with-time-stamp-and-navigate-current-file-with-check (&key position size)
  (interactive)
  (save-buffer-with-time-stamp)
  (navigate-current-file-with-check :position position :size size))

(defun rotate-browser ()
  (interactive)
  (when initialized
    (close-browser)
    (case *browser-position*
      ((0 1 2)
       (incf *browser-position*))
      ((3)
       (setq *browser-position* 0))))
  (navigate-current-buffer))


;; tool-bar
(defun tool-bar-update-browser ()
  (or initialized :disable))

(defun browser-tool-bar ()
  (create-tool-bar
   'browser-tool-bar
   (merge-pathnames "toolbar-browser.bmp" (etc-path))
   '(("browser ŕ\" 0 navigate-current-buffer)
     ("browser ̕\ʒuύX" 1 rotate-browser tool-bar-update-browser)
     ("browser " 2 close-browser tool-bar-update-browser)
     )))

; tool-bar o^
(define-command-bar 'browser-tool-bar "Browser(&R)")

; tool-bar 폜
;(delete-command-bar 'browser-tool-bar)
